<?php
defined('_JEXEC') or 	die( 'Direct Access to ' . basename( __FILE__ ) . ' is not allowed.' ) ;
/**
 * A custom field plugin to automatically add buyers to Joomla! groups
 * @author Reinhold Kainhofer, office@open-tools.net
 * @package VirtueMart
 * @subpackage vmcustom
 * @copyright Copyright (C) 2013 Reinhold Kainhofer, Open Tools
 * @license GNU/GPLv3+, http://www.gnu.org/copyleft/gpl-3.0.html 
 *
 * http://www.open-tools.net/
 */
if (!class_exists('vmCustomPlugin')) require(JPATH_VM_PLUGINS . DS . 'vmcustomplugin.php');

class plgVmCustomBuyer_Assign_Group extends vmCustomPlugin {
	var $counter=0;
	function __construct(& $subject, $config) {
		parent::__construct($subject, $config);
		$this->_tablepkey = 'id';
		$this->tableFields = array_keys($this->getTableSQLFields());
		$varsToPush = array(
			'joomla_groups'=>array(array(), 'array'),
			'joomla_groups_remove'=>array(array(), 'array'),
			'shopper_groups'=>array(array(), 'array'),
			'shopper_groups_remove'=>array(array(), 'array'),
			'purchased_status' => array(array(), 'array'),
		);
		if(!defined('VM_VERSION') or VM_VERSION < 3){
			$this->setConfigParameterable ('custom_params', $varsToPush);
		} else {
			$this->setConfigParameterable ('customfield_params', $varsToPush);
		}
	}

	/**
	 * @see Form displayed in the product edit page in the BE, configure the download file
	 * @author Reinhold Kainhofer
	 */
	function plgVmOnProductEdit($field, $product_id, &$row,&$retValue) {
		if ($field->custom_element != $this->_name) return '';
		$html = '';
		if(!defined('VM_VERSION') or VM_VERSION < 3){ 
			$this->parseCustomParams ($field); // Not needed in VM3!
			$paramName = 'custom_param';
		} else {
			$paramName = 'customfield_params';
		}
		$html .= '<table class="admintable">';
		$html .= VmHTML::row (array('JHTML', '_'),'VMCUSTOM_BUYER_GROUP_JOOMLA', 'access.usergroup', $paramName.'['.$row.'][joomla_groups][]', $field->joomla_groups, ' multiple data-placeholder=" "', false);
		$html .= VmHTML::row (array('JHTML', '_'),'VMCUSTOM_BUYER_GROUP_JOOMLA_REMOVE', 'access.usergroup', $paramName.'['.$row.'][joomla_groups_remove][]', $field->joomla_groups_remove, ' multiple data-placeholder=" "', true);
		
		$html .= VmHTML::row (array('ShopFunctions', 'renderShopperGroupList'), 'VMCUSTOM_BUYER_GROUP_SHOPPER', $field->shopper_groups, TRUE, $paramName.'['.$row.'][shopper_groups][]', ' ');
		$html .= VmHTML::row (array('ShopFunctions', 'renderShopperGroupList'), 'VMCUSTOM_BUYER_GROUP_SHOPPER_REMOVE', $field->shopper_groups_remove, TRUE, $paramName.'['.$row.'][shopper_groups_remove][]', ' ');

		$html .= '</table></fieldset>';
		$retValue .= $html;
		$row++;
		return true ;
	}

	public function plgVmOnStoreInstallPluginTable($psType, $data, $nameOrTable) {
		return $this->onStoreInstallPluginTable($psType);
	}

	// VM2 Compat:
	function plgVmDeclarePluginParamsCustom($psType,$name,$id, &$data){
		return $this->declarePluginParams('custom', $name, $id, $data);
	}
	function plgVmDeclarePluginParamsCustomVM3(&$data){
		return $this->declarePluginParams('custom', $data);
	}
	function plgVmGetTablePluginParams($psType, $name, $id, &$xParams, &$varsToPush){
		return $this->getTablePluginParams($psType, $name, $id, $xParams, $varsToPush);
	}

	function plgVmSetOnTablePluginParamsCustom($name, $id, &$table){
		return $this->setOnTablePluginParams($name, $id, $table);
	}

	function plgVmOnDisplayEdit($virtuemart_custom_id,&$customPlugin){
		return $this->onDisplayEditBECustom($virtuemart_custom_id,$customPlugin);
	}

	/**
	 * Create the database table for this plugin.
	 */
	public function getVmPluginCreateTableSQL() {
		return $this->createTableSQL('VM Buyer Assign Groups Plugin tracking');
	}

	function getTableSQLFields() {
		$SQLfields = array(
		  'id' => 'int(1) UNSIGNED NOT NULL AUTO_INCREMENT',
		  'order_id' => 'int(11) UNSIGNED NOT NULL DEFAULT \'0\'',
		  'user_id' => 'int(11) UNSIGNED DEFAULT \'0\'',
		  'virtuemart_user_id' => 'int(11) UNSIGNED NOT NULL DEFAULT \'0\'',
		  'virtuemart_custom_id' => 'int(11) UNSIGNED NOT NULL DEFAULT \'0\'',
		  'virtuemart_customfield_id' => 'int(11) UNSIGNED NOT NULL DEFAULT \'0\'',
		  'virtuemart_order_item_id' => 'int(11) UNSIGNED DEFAULT \'0\'',
		  'group_id' => 'int(11) UNSIGNED DEFAULT \'0\'',
		  'group_type' => 'int(1) UNSIGNED DEFAULT \'0\'',
		  'group_add' => 'tinyint(1) DEFAULT \'1\'',
		  'modified' => 'tinyint(1) DEFAULT \'0\'',
		);
		return $SQLfields;
	}
	
	/* This function does NOT load the whole user, it just loads enough to have the Joomla
	   groups and the VM shopper groups, i.e. it loads all data from the vmusers and the
	   vmuser_shoppergroups table, and the Joomla user information, but nothing else */
	function loadUserGroupData($uid) {
		if (empty($uid)) return null;

		$db = JFactory::getDBO();

		$userModel = VmModel::getModel('user');
		$user = $userModel->getTable('vmusers');
		$user->load((int)$uid);
		$user->JUser = JUser::getInstance($uid);

		// Add the virtuemart_shoppergroup_ids
		$xrefTable = $userModel->getTable('vmuser_shoppergroups');
		$user->shopper_groups = $xrefTable->load($uid);
		if(empty($user->shopper_groups)) $user->shopper_groups = array();

		$site = JFactory::getApplication ()->isSite ();
		if ($site) {
			$shoppergroupmodel = VmModel::getModel('ShopperGroup');
			$shoppergroupmodel->appendShopperGroups($user->shopper_groups,$user->JUser,$site);
		}
		$user->shopper_groups = (array)$user->shopper_groups;

		return $user;
	}
	
	/** This functions makes sure the user model clears the cache of the given user, because the 
	    user data was modified directly in the database. In VM2 there is only the last user 
	    cached, so make sure to change the user id by first setting it to 0 and then to the real 
	    uid. Otherwise the cache would not be erased if the uid was the last requested. */
	function clearUserCache($uid) {
		$userModel = VmModel::getModel('user');
		$userModel->_data = null;
		$userModel->setId(0);   // <- Make sure the cache is really, really erased in VM2!
		$userModel->setId($uid);
	}
	
	function setShopperGroups($uid, $groups) {
		$this->clearUserCache($uid);
		$noError = true;
		$userModel = VmModel::getModel('user');
		$shoppergroupmodel = VmModel::getModel('ShopperGroup');
		$defaultgroup = $shoppergroupmodel->getDefault(0);

		if(empty($groups) or ($groups == array($defaultgroup->virtuemart_shoppergroup_id))) {
			$groups = array();
		}

		// Bind the form fields to the table
		$shoppergroupData = array('virtuemart_user_id'=>$uid,
			'virtuemart_shoppergroup_id'=>$groups);
		$user_shoppergroups_table = $userModel->getTable('vmuser_shoppergroups');
		$shoppergroupData = $user_shoppergroups_table -> bindChecknStore($shoppergroupData);
		
		if(!defined('VM_VERSION') or VM_VERSION < 3){
			// getErrors was removed in VM3!
			$errors = $user_shoppergroups_table->getErrors();
			foreach($errors as $error){
				$this->setError($error);
				vmError('Set shoppergroup '.$error);
				$noError = false;
			}
		}
		$user_shoppergroups_table->emptyCache();
		return $noError;
	}
	
	function addShopperGroup($user, $group) {
		$groups = $user->shopper_groups;
		if (!in_array($group, $groups)) {
			$groups[] = $group;
			return $this->setShopperGroups($user->virtuemart_user_id, $groups);
		}
		return false;
	}
	function removeShopperGroup($user, $group) {
		$groups = $user->shopper_groups;
		if (in_array($group, $groups)) {
			$groups=array_diff($groups, array($group));
			return $this->setShopperGroups($user->virtuemart_user_id, $groups);
		}
		return false;
	}
	function setModifiedFlag ($entry, $value) {
		$db = JFactory::getDbo();
		$db->setQuery("UPDATE `".$this->_tablename."` SET `modified`=".(int)$value." WHERE `id`=".$entry['id']);
		if (!$db->query()) {
			JFactory::getApplication()->enqueueMessage("SQL query FAILED: Message: ".$db->getErrorMsg().", SQL: <pre>".$db->getQuery()."</pre>", 'error');
		}
	}

	function updateOrderStatus ($order_id, $order_status, $old_order_status) {
		// 1) Load all entries associated with this order
		$db = JFactory::getDbo();
		$db->setQuery("SELECT * FROM `".$this->_tablename."` WHERE `order_id` = ".(int)$order_id . ";");
		$orderEntries = $db->loadAssocList();
		if (is_null($orderEntries)) {
			JFactory::getApplication()->enqueueMessage("SQL query FAILED: Message: ".$db->getErrorMsg(), 'error');
		}
		if (empty($orderEntries)) {
			// Nothing to do, exit!
			return;
		}
		
		// 2) Load all associated custom field definitions (to retrieve the order states)
		$customsModel = VmModel::getModel('custom');
		$userModel = VmModel::getModel('user');
		$pstates = array();
		$users = array();
		foreach ($orderEntries as $e) {
			$uid = $e['virtuemart_user_id'];
			if (!isset($users[$uid])) {
				$users[$uid] = $this->loadUserGroupData($uid);
			}
			$cid = $e['virtuemart_custom_id'];
			if (!isset($customs[$cid])) {
				$customsModel->setId($cid);
				$c = $customsModel->getData();
				$this->parseCustomParams($c, 'custom_params');
				$pstates[$cid] = $c->purchased_status;
			}
		}
		
		// 3) Check which custom field entries need some change
		foreach ($orderEntries as $e) {

			try {
				$uid = $e['virtuemart_user_id'];
				$cid = $e['virtuemart_custom_id'];
				$purchased   =  in_array($order_status, $pstates[$cid]) && !in_array($old_order_status, $pstates[$cid]);
				$unpurchased = !in_array($order_status, $pstates[$cid]) &&  in_array($old_order_status, $pstates[$cid]);

				$modified = false;
				if ($purchased) {
					if ($e['group_type']==0) { // Joomla User Group
						if ($e['group_add']==1 && !in_array($e['group_id'], $users[$uid]->JUser->groups)) { // Add to Joomla user group
							$modified = JUserHelper::addUserToGroup ($uid, $e['group_id']);
						} elseif ($e['group_add']==0 && in_array($e['group_id'], $users[$uid]->JUser->groups)) { // Remove from Joomla user group
							$modified = JUserHelper::removeUserFromGroup ($uid, $e['group_id']);
						}
					} elseif ($e['group_type']=1) { // Virtuemart Shopper Group
						if ($e['group_add']==1) { // Add to Virtuemart Shopper group
							$modified = $this->addShopperGroup($users[$uid], $e['group_id']);
						} elseif ($e['group_add']==0) { // Remove from Virtuemart Shopper group
							$modified = $this->removeShopperGroup ($users[$uid], $e['group_id']);
						}
					}
					if ($modified) {
						$this->setModifiedFlag ($e, $modified);
						// clear the user model cache and update update the $users array so the next step in the loop has the correct groups if the user is added to another group
						$this->clearUserCache($uid);
						$users[$uid] = $this->loadUserGroupData($uid);
					}
				} elseif ($unpurchased && $e['modified']) {
					// Undo the addition/removal when a product purchase is cancelled
					if ($e['group_type']==0) { // Joomla User Group
						if ($e['group_add']==1) { // Remove from Joomla user group again
							$modified = JUserHelper::removeUserFromGroup ($uid, $e['group_id']);
						} elseif ($e['group_add']==0) { // Add to Joomla user group again
							$modified = JUserHelper::addUserToGroup ($uid, $e['group_id']);
						}
					} elseif ($e['group_type']==1) { // Virtuemart Shopper Group
						if ($e['group_add']==1) { // Remove from Virtuemart Shopper group again
							$modified = $this->removeShopperGroup($users[$uid], $e['group_id']);
						} elseif ($e['group_add']==0) { // Add from Virtuemart Shopper group again
							$modified = $this->addShopperGroup ($users[$uid], $e['group_id']);
						}
					}
					// Clear the modified flag in the database
					$this->setModifiedFlag ($e, 0);
				}
				// Reload the user data, because shopper groups are NOT automatically updated in the data structure in memory!
				$this->clearUserCache($uid);
				$users[$uid] = $this->loadUserGroupData($uid);
			}
			catch (Exception $ex) {
				JFactory::getApplication()->enqueueMessage("ERROR:  <pre>".$ex->getMessage()."</pre>", 'info');
				JLog::add('Unable to add/remove user to/from group: '.$ex->getMessage());
			}
		}
	}
	
	// VM2.x compat:
	function plgVmOnUpdateOrder($data, $old_order_status) {
		return $this->updateOrderStatus($data->virtuemart_order_id, $data->order_status, $old_order_status);
	}
	// VM3.x
	function plgVmOnUpdateOrderShipment($data, $old_order_status) {
		return $this->updateOrderStatus($data->virtuemart_order_id, $data->order_status, $old_order_status);
	}
	
	function plgVmConfirmedOrder($cart, $order) {
		// Each custom field will have its own values, so we need to handle all purchased products!
		$vuid = $order['details']['BT']->virtuemart_user_id;
		$userModel = VmModel::getModel('user');
		$user = $userModel->getCurrentUser();
		$uid = $user->JUser->id;

		$order_id = $order['details']['BT']->virtuemart_order_id;
		$orderModel = VmModel::getModel('orders');
		$order = $orderModel->getOrder($order_id);

		$values = array();
		$customModel = VmModel::getModel('customfields');
		// Collect all group additions/removals that need to be stored in the database; Will be used on order change
		foreach ($order['items'] as $item) {
			if (method_exists($customModel, 'getCustomEmbeddedProductCustomFields')) { // V3.x
				$customs = $customModel->getCustomEmbeddedProductCustomFields (array ($item->virtuemart_product_id));
			} else {
				$customs = $customModel->getproductCustomslist ($item->virtuemart_product_id); // V2.x
			}
			foreach ($customs as $field) {
				if ($field->custom_element != $this->_name) continue;
				
				$cdata = array ((int)$order_id, $uid, $vuid, (int)$field->virtuemart_custom_id, (int)$field->virtuemart_customfield_id, (int)$item->virtuemart_order_item_id);
				foreach ($field->joomla_groups as $g) {
					$values[] = join(", ", array_merge($cdata, array((int)$g, 0, 1)));
				}
				foreach ($field->joomla_groups_remove as $g) {
					$values[] = join(", ", array_merge($cdata, array((int)$g, 0, 0)));
				}
				foreach ($field->shopper_groups as $g) {
					$values[] = join(", ", array_merge($cdata, array((int)$g, 1, 1)));
				}
				foreach ($field->shopper_groups_remove as $g) {
					$values[] = join(", ", array_merge($cdata, array((int)$g, 1, 0)));
				}
			}
		}
		
		if (!empty($values) && $uid==0 && $vuid==0) {
			JFactory::getApplication()->enqueueMessage(JText::_('VMCUSTOM_BUYER_GROUP_NO_UID'), 'error');
			return;
		}

		if (!empty($values)) {
			$db = JFactory::getDbo();
			$query = $db->getQuery(true);
			$query->insert($this->_tablename);
			$query->columns('`order_id`, `user_id`, `virtuemart_user_id`, `virtuemart_custom_id`, `virtuemart_customfield_id`, `virtuemart_order_item_id`, `group_id`, `group_type` , `group_add`');
			$query->values($values);
			$db->setQuery($query);
			if (!$db->query()) {
				JFactory::getApplication()->enqueueMessage("SQL query FAILED: Message: ".$db->getErrorMsg().", SQL: <pre>".$query->dump()."</pre>", 'error');
			}
			$this->updateOrderStatus($order_id, $order['details']['BT']->order_status, '');
		}
	}

    /**
     * plgVmOnSelfCallBE ... Called to execute some plugin action in the backend (e.g. set/reset dl counter, show statistics etc.)
     */
    function plgVmOnSelfCallBE($type, $name, &$output) {
        if ($name != $this->_name || $type != $this->_type) return false;
        vmDebug('plgVmOnSelfCallBE');
        $user = JFactory::getUser();
        $authorized = ($user->authorise('core.admin','com_virtuemart') or
                       $user->authorise('core.manage','com_virtuemart'));
        $json = array();
        $json['authorized'] = $authorized;
        if (!$authorized) return FALSE;

        $action = vRequest::getCmd('action');
        $json['action'] = $action;
        $json['success'] = 0; // default: unsuccessfull
        switch ($action) {
			case "check_update_access":
				$order_number = vRequest::getString('order_number');
				$order_pass = vRequest::getString('order_pass');
				$json = $this->checkUpdateAccess($order_number, $order_pass, $json);
				break;
        }
        
        // Also return all messages (in HTML format!):
        // Since we are in a JSON document, we have to temporarily switch the type 
        // to HTML to make sure the html renderer is actually used
        $document = JFactory::getDocument ();
        $previoustype = $document->getType();
        $document->setType('html');
        $msgrenderer = $document->loadRenderer('message');
        $json['messages'] = $msgrenderer->render('Message');
        $document->setType($previoustype);

        // WORKAROUND for broken (i.e. duplicate) content-disposition headers in Joomla 2.x:
        // We request everything in raw and here send the headers for JSON and return
        // the raw output in json format
        $document =JFactory::getDocument();
        $document->setMimeEncoding('application/json');
        JResponse::setHeader('Content-Disposition','attachment;filename="opentools_update_access.json"');
        $output = json_encode($json);
    }
    
    protected function checkUpdateAccess($order_number, $order_pass, $json = array()) {
		// First, extract the update server URL from the manifest, then load 
		// the update XML from the update server, extract the download URL, 
		// append the order number and password and check whether access is 
		// possible.
		$json['success'] = FALSE;
		$xml = simplexml_load_file($this->_xmlFile);
		if (!$xml || !isset($xml->updateservers)) {
			JFactory::getApplication()->enqueueMessage(JText::sprintf('OPENTOOLS_XMLMANIFEST_ERROR', $this->_xmlFile), 'error');
			return $json;
		}
		$updateservers = $xml->updateservers;
		foreach ($updateservers->children() as $server) {
			if ($server->getName()!='server') {
				JFactory::getApplication()->enqueueMessage(JText::sprintf('OPENTOOLS_XMLMANIFEST_ERROR', $this->_xmlFile), 'error');
				continue;
			}
			$updateurl = html_entity_decode((string)$server);
			$updatescript = simplexml_load_file($updateurl);
			if (!$updatescript) {
				JFactory::getApplication()->enqueueMessage(JText::sprintf('OPENTOOLS_UPDATESCRIPT_ERROR', $updateurl), 'error');
				continue;
			}
			$urls = $updatescript->xpath('/updates/update/downloads/downloadurl');
			while (list( , $node) = each($urls)) {
				$downloadurl = (string)($node);
				if ($order_number) {
					$downloadurl .= (parse_url($downloadurl, PHP_URL_QUERY) ? '&' : '?') . 'order_number=' . urlencode($order_number);
				}
				if ($order_pass) {
					$downloadurl .= (parse_url($downloadurl, PHP_URL_QUERY) ? '&' : '?') . 'order_pass=' . urlencode($order_pass);
				}
				$downloadurl .= (parse_url($downloadurl, PHP_URL_QUERY) ? '&' : '?') . 'check_access=1';

				$headers = get_headers($downloadurl);
				list($version, $status_code, $msg) = explode(' ',$headers[0], 3);
				
				// Check the HTTP Status code
				switch($status_code) {
					case 200:
						$json['success'] = TRUE;
						JFactory::getApplication()->enqueueMessage($msg, 'message');
						$this->setupUpdateCredentials($order_number, $order_pass);
						break;
					default:
						JFactory::getApplication()->enqueueMessage($msg, 'error');
						// Clear the credentials...
						$this->setupUpdateCredentials("", "");
						break;
				}
				$this->setAndSaveParams(array(
					'update_credentials_checked'=>$json['success'],
					'order_number' => $order_number,
					'order_pass' => $order_pass,
				));
			}
		}
		return $json;
    }

    protected function setAndSaveParams($params) {
		$db = JFactory::getDbo();
		$query = $db->getQuery(true)
			->select('extension_id')
			->from('#__extensions')
			->where('folder = '.$db->quote($this->_type))
			->where('element = '.$db->quote($this->_name))
			->where('type =' . $db->quote('plugin'))
			->order('ordering');

		$plugin = $db->setQuery($query)->loadObject();
		if (!$plugin)
			return;
		$pluginId=$plugin->extension_id;
		
		foreach ($params as $param=>$parvalue) {
			$this->params->set($param, $parvalue);
		}
		
		$extensions = JTable::getInstance('extension');
		$extensions->load($pluginId);
		$extensions->bind(array('params' => $this->params->toString()));
		
		// check and store 
		if (!$extensions->check()) {
			$this->setError($extensions->getError());
			return false;
		}
		if (!$extensions->store()) {
			$this->setError($extensions->getError());
			return false;
		}
    }


	protected function setupUpdateCredentials($ordernumber, $orderpass) {
		$db = JFactory::getDbo();
		$query = $db->getQuery(true)
			->select('extension_id AS id')
			->from('#__extensions')
			->where('folder = '.$db->quote($this->_type))
			->where('element = '.$db->quote($this->_name))
			->where('type =' . $db->quote('plugin'))
			->order('ordering');

		$plugin = $db->setQuery($query)->loadObject();
		if (empty($plugin))
			return;

		$ordernumber = preg_replace("/[^-A-Za-z0-9_]/", '', $ordernumber);
		$orderpass = preg_replace("/[^-A-Za-z0-9_]/", '', $orderpass);
		
		$extra_query = array();
		if ($ordernumber!='') {
			$extra_query[] = 'order_number='.preg_replace("/[^-A-Za-z0-9_]/", '', $ordernumber);
		}
		if ($orderpass!='') {
			$extra_query[] = 'order_pass='.preg_replace("/[^-A-Za-z0-9_]/", '', $orderpass);
		}
		$extra_query = implode('&amp;', $extra_query);
		
		// The following code is based on Nicholas K. Dionysopoulos' Joomla Pull request:
		//     https://github.com/joomla/joomla-cms/pull/2508
		
		// Load the update site record, if it exists
		$db = JFactory::getDbo();
		$query = $db->getQuery(true)
			->select('update_site_id AS id')
			->from($db->qn('#__update_sites_extensions'))
			->where($db->qn('extension_id').' = '.$db->q($plugin->id));
		$db->setQuery($query);
		$updateSites = $db->loadObjectList();

		foreach ($updateSites as $updateSite) {
			// Update the update site record
			$query = $db->getQuery(true)
				->update($db->qn('#__update_sites'))
				->set('extra_query = '.$db->q($extra_query))
				->set('last_check_timestamp = 0')
				->where($db->qn('update_site_id').' = '.$db->q($updateSite->id));
			$db->setQuery($query);
			$db->execute();

			// Delete any existing updates (essentially flushes the updates cache for this update site)
			$query = $db->getQuery(true)
				->delete($db->qn('#__updates'))
				->where($db->qn('update_site_id').' = '.$db->q($updateSite->id));
			$db->setQuery($query);
			$db->execute();
		}
		
	}

}

// No closing tag